﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PrecastConcretePlantContracts.ViewModels;
using PrecastConcretePlantContracts.BindingModels;

namespace PrecastConcretePlantContracts.BusinessLogicsContracts
{
    public interface IReportLogic
    {
        // Получение списка компонент с указанием, в каких изделиях используются
        List<ReportReinforcedComponentViewModel> GetReinforcedComponents();

        // Получение списка заказов за определенный период
        List<ReportOrdersViewModel> GetOrders(ReportBindingModel model);

        // Получение изделий магазина
        List<ReportShopReinforcedViewModel> GetShopReinforceds();

        // Получение заказов по дате
        List<ReportOrdersByDateViewModel> GetGroupedByDateOrders();

        // Сохранение компонент в файл-Word
        void SaveReinforcedsToWordFile(ReportBindingModel model);

        // Сохранение магазинов в ворд
        void SaveShopsToWordFile(ReportBindingModel model);

        // Сохранение компонент с указаеним продуктов в файл-Excel
        void SaveReinforcedComponentToExcelFile(ReportBindingModel model);

        // Сохранение изделий магазина в эксель
        void SaveShopReinforcedToExcelFile(ReportBindingModel model);

        // Сохранение заказов в файл-Pdf
        void SaveOrdersToPdfFile(ReportBindingModel model);

        //Группированные заказы в пдф
        void SaveGroupedOrdersToPdfFile(ReportBindingModel model);
    }
}
