﻿using PrecastConcretePlantDataModels.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PrecastConcretePlantContracts.ViewModels
{
    public class ShopViewModel : IShopModel
    {
        public int Id { get; set; }

        [DisplayName("Название магазина")]
        public string ShopName { get; set; } = string.Empty;

        [DisplayName("Адрес")]
        public string Address { get; set; } = string.Empty;

        [DisplayName("Дата открытия")]
        public DateTime DateOpening { get; set; } = DateTime.Now;

        public List<Tuple<string, double, int>> ShortReinforcedInfo { get; set; } = new();
        public Dictionary<int, (IReinforcedModel, int)> ShopReinforceds
        {
            get;
            set;
        } = new();

        [DisplayName("Максимальное количество изделий")]
        public int ReinforcedsMax { get; set; }
    }
}
